
-- PreConditions: None
-- PostConditions: None
-- Comments: function moves the list up and down
function DKPMaster_ScrollList(inc)
	if(DKPM_RaidOnlyOn and GetNumRaidMembers() > 0) then
		if(inc == "+")then
			DKPM_ListIndex = 1
		elseif (inc == "-") then
			DKPM_ListIndex = DKPM_numFrame2entries + 1
		end
	else
		if(inc == "+")then
			local temp = DKPM_ListIndex + 20
			if(temp < table.getn(DKPM_DKP) ) then
				DKPM_ListIndex = temp
			end
		elseif (inc == "-") then
			local temp = DKPM_ListIndex - 20
			if(temp > 0 ) then
				DKPM_ListIndex = temp
			end
		end
	end
	DKPMaster_RefreshRoster();  -- refreshes the change
end

-- PreConditions: None
-- PostConditions: None
-- Comments: updates frames 3 and 4 of selected player
function DKPMaster_OnClick(arg1)
	--if(DKPM_RAIDLEADER) then
		 if( getglobal("DKPMaster_AdjustmentFrame"):IsVisible() ) then
			--do nothing
		else
			-- shows frame3 if not visible 
			DKPM_FramesOpen[3]=true
			getglobal("DKPMaster_AdjustmentFrame"):Show()
		end
	--end
	
	
	local buttonName = this:GetName()
	local indexFromButton = 0

	
	for i=1, DKPM_numFrame2entries do
		local button = "DKPMaster_frame2_entry"..i
		if(buttonName==button) then
			indexFromButton = i
		end
	end
	
	DKPMaster_RefreshRoster()  --clears any highlights
	local r=1
	local g=1
	local b=0
	local a=1
	getglobal("DKPMaster_frame2_entry"..indexFromButton.."_name"):SetVertexColor(r, g, b, a)
	getglobal("DKPMaster_frame2_entry"..indexFromButton.."_total"):SetVertexColor(r, g, b, a)
	getglobal("DKPMaster_frame2_entry"..indexFromButton.."_class"):SetVertexColor(r, g, b, a)
	getglobal("DKPMaster_frame2_entry"..indexFromButton.."_date"):SetVertexColor(r, g, b, a)
		
	DKPMtotalIndex = indexFromButton + DKPM_ListIndex - 1  --index was off by 1 somehow

	local tempName;
	local tempDKP;
	local tempClass;
	
	local counter = 0;
	for i,localdkp in DKPM_DKP do
		tempName = localdkp.name;
		tempDKP = localdkp.dkp;
		tempClass = localdkp.class;
		tempDate = localdkp.date;
		counter = counter + 1;
		if(counter == DKPMtotalIndex) then 
			break;
		end
	end 
	
	DKPMtotalIndexName = tempName;
	DKPMtotalIndexClass = tempClass;
	getglobal("DKPMaster_AdjustmentPlayerBox"):SetText(tempName);
	--getglobal("DKPMasterframe4_TotalBox"):SetText(tempDKP)
end

-- PreConditions: None
-- PostConditions: None
-- Comments: notifies the raid of their current DKP
function DKPMaster_NotifyAll()
	local num = GetNumPartyMembers();
	local numRaid = GetNumRaidMembers();
	local membername;
	local groupname;
	local channelname;
	
	-- setup what type of group it is
	if(numRaid > 0) then
		groupname = "raid"
		channelname = "RAID"
	elseif(num > 0) then
		groupname = "party"
		channelname = "PARTY"
		numRaid = num;
	else
		DKPM_Msg("Must be in a group or a raid");
		return;
	end
	
	for i = 1, numRaid, 1 do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
		membername = UnitName(groupname .. i); 
		if(online == 1) then
			--skrim(membername.." in list");
			--if(DKPM_DKP[membername] ~= nil) then
				DKPMaster_Notify(membername);
			--end
		end
	end
end

-- PreConditions: None
-- PostConditions: None
-- Comments: Shows the Log frame
function DKPM_ShowLogs()
	getglobal("DKPMaster_LogFrame"):Show();
	DKPMaster_RefreshLogs();
end
-- PreConditions: None
-- PostConditions: None
-- Comments: Shows the Item frame
function DKPM_ShowItems()
	getglobal("DKPMaster_ItemLogFrame"):Show();
	DKPMaster_RefreshItems();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: sorts GUI list by name
function DKPMaster_frame2_sort_by_name()
	local localdkp = DKPM_DKP;
	DKPM_DKP = DKPM_alphaSort(localdkp);
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: sorts GUI list by class
function DKPMaster_frame2_sort_by_class()
	local localdkp = DKPM_DKP;
	DKPM_DKP = DKPM_classSort(localdkp);
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: Toggles the frame1 options frame.
function DKPM_Toggle_frame2_options()
	local show;
	if(MainOptionsShow) then
		MainOptionsShow = false;
		show = true;
		DKPMaster_ToggleFrame(2, true);
	else
		MainOptionsShow = true;
		show = false;
		DKPMaster_Toggle(2,show);
		DKPMaster_Toggle(3,show);
		DKPMaster_Toggle(4,show);
		DKPMaster_Toggle(5,show);
		DKPMaster_Toggle(6,show);
		DKPMaster_Toggle(7,show);
		DKPMaster_Toggle(8,show);
		DKPMaster_Toggle(9,show);
		DKPMaster_Toggle(10,show);
		DKPMaster_Toggle(11,show);
		DKPMaster_Toggle(12,show);
		MCOptionsShow = false;
		BWLOptionsShow = false;
		AQOptionsShow = false;
		OnyxiaOptionsShow = false;
		WorldBossesOptionsShow = false;
		HelpOptionsShow = false;
		AboutFrameShow = false;
	end
	
	DKPMaster_Toggle(1, MainOptionsShow);
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPMaster_frame2_RaidOnlyClick(pChecked)
	if(pChecked == nil) then
		DKPM_RaidOnlyOn = false;
		getglobal("DKPMasterframe2_RaidOnlyCheckBox"):SetText("Off");
	else
		DKPM_RaidOnlyOn = true;
		getglobal("DKPMasterframe2_RaidOnlyCheckBox"):SetText("On");
	end
	getglobal("DKPMasterframe2_RaidOnlyCheckBox"):Show();
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPM_frame2_snapshot(dkp)
	if(dkp == nil) then
		dkp = 0;
	end
	if(dkp == "") then
		dkp = 0;
	end
	--if(tonumber(dkp) >= 0) then
		if(DKPMSnapShotEventName == nil) then
			addDKP(dkp, "Snapshot", "Outdoor World Bosses"); 
		else
			addDKP(dkp, "Snapshot", DKPMSnapShotEventName);
		end
		--addDKP(dkp, "Snapshot", DKPM_CurrentZone);
		DKPMaster_RefreshRoster();
	--else
	--	skrim("Failed to add snapshot!");
	--end
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPM_Toggle_frame2_whisperclassdkp()
	local num = GetNumPartyMembers();
	local numRaid = GetNumRaidMembers();
	local membername;
	local groupname;
	local channelname;
	
	if (DKPM_DISABLED[DKPM_ME] == false and DKPM_RAIDLEADER == true) then
		-- setup what type of group it is
		if(numRaid > 0) then
			groupname = "raid"
			channelname = "RAID"
		elseif(num > 0) then
			groupname = "party"
			channelname = "PARTY"
			numRaid = num;
		else
			DKPM_Msg("Must be in a group or a raid");
			return;
		end
		
		for i = 1, numRaid, 1 do
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			membername = UnitName(groupname .. i); 
			for i,localdkp in DKPM_DKP do
				if(localdkp.name == membername) then
					if(localdkp.class == DKPM_WhisperClassSelected) then
						SendChatMessage("Current DKP is -- "..localdkp.dkp, "WHISPER", DKPM_RACIAL_CHAT, localdkp.name);
					end
				end
			end
		end	
	end
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPM_Toggle_frame1_help()
	local show;
	if(HelpOptionsShow) then
		HelpOptionsShow = false;
		show = true;
	else
		HelpOptionsShow = true;
		show = false;
		DKPMaster_Toggle(2,show);
		DKPMaster_Toggle(3,show);
		DKPMaster_Toggle(4,show);
		DKPMaster_Toggle(5,show);
		DKPMaster_Toggle(6,show);
		DKPMaster_Toggle(7,show);
		DKPMaster_Toggle(8,show);
		DKPMaster_Toggle(9,show);
		DKPMaster_Toggle(10,show);
		MCOptionsShow = false;
		BWLOptionsShow = false;
		AQOptionsShow = false;
		OnyxiaOptionsShow = false;
		WorldBossesOptionsShow = false;
	end
	
	DKPMaster_Toggle(11, HelpOptionsShow);
end

-- PreConditions: None
-- PostConditions: None
-- Comments: gives awards DKP start on time
function DKPMaster_frame1_award_ontime()
	--local dkpIncrease = DKPMasterframe1_dkpBox_text:GetText()
	awardAllDKP(tonumber(DKPM_DKP_Points[1]), "on time");
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: gives awards DKP end time
function DKPMaster_frame1_award_endtime()
	--local dkpIncrease = DKPMasterframe1_dkpBox_text:GetText()
	awardAllDKP(tonumber(DKPM_DKP_Points[2]), "end time");
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: shows the imports data frame
function DKPMaster_frame1_import()
	getglobal("DKPMaster_ImportFrame"):Show();
	getglobal("DKPMaster_Frame2"):Hide();
end
-- PreConditions: None
-- PostConditions: None
-- Comments: shows the imports data frame
function DKPMaster_frame1_export()
	DKPMaster_loadExport();
	getglobal("DKPM_Controls_Export_Frame"):Show();
	getglobal("DKPMaster_Frame2"):Hide();
end


-- PreConditions: None
-- PostConditions: None
-- Comments: shows the imports data frame
function DKPMSendClassToChannel()
	local num = GetNumPartyMembers();
	local numRaid = GetNumRaidMembers();
	local membername;
	local groupname;
	local channelname;
	local channelIndex;
	local classname = DKPM_SendChannelClassSelected;
	local channelname2 = DKPMChannelName;
	local chattype = DKPMChannelType;
	
	--channelIndex = GetChannelName(channelname2);
	--skrim(channelIndex);
	--skrim(channelname2);
	--skrim(chattype);
	
	if (DKPM_DISABLED[DKPM_ME] == false) then
		-- setup what type of group it is
		if(numRaid > 0) then
			groupname = "raid"
			channelname = "RAID"
		elseif(num > 0) then
			groupname = "party"
			channelname = "PARTY"
			numRaid = num;
		else
			DKPM_Msg("Must be in a group or a raid");
			return;
		end
		
		for i = 1, numRaid, 1 do
			foundname = false;
			local name, rank, subgroup, level, class, fileName, zone, online, isDead = GetRaidRosterInfo(i);
			if(online == 1) then
				membername = UnitName(groupname .. i) 
				for i,localdkp in DKPM_DKP do
					if(localdkp.name == membername and localdkp.class == classname and channelname ~= "General") then
						if(chattype == "CHANNEL" or chattype == "WHISPER") then
							channelIndex = GetChannelName(channelname2);
							--skrim(channelIndex);
							--SendChatMessage(classname.." Points", chattype, DKPM_RACIAL_CHAT, channelIndex);
							SendChatMessage(membername.."...."..localdkp.dkp, chattype, DKPM_RACIAL_CHAT, channelIndex);
						else
							--skrim(channelIndex);
							--SendChatMessage(classname.." Points", chattype, DKPM_RACIAL_CHAT);
							SendChatMessage(membername.."...."..localdkp.dkp, chattype, DKPM_RACIAL_CHAT);
						end
					end
				end
			end
		end	
	end
end

-- PreConditions: None
-- PostConditions: None
-- Comments: Allows for the up and down arrows to work on frame 2  "+" = up, "-" = down
function DKPMaster_frame2_DKPincrease(upDown)
	if(upDown=="+") then
		local current = getglobal("DKPMasterframe2_dkpBox_text"):GetText()
		current = current + 1
		getglobal("DKPMasterframe2_dkpBox_text"):SetText(current)
	elseif(upDown=="-") then
		local current = getglobal("DKPMasterframe2_dkpBox_text"):GetText()
		current = current - 1
		getglobal("DKPMasterframe2_dkpBox_text"):SetText(current)
	end
end